/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.ergebniskonflikt.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.ergebniskonflikt.entity.ErgebnisKonflikt;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class ErgebnisKonfliktExtendedDAO extends AbstractErgebnisKonfliktDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: ErgebnisOrderByIdNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT k FROM ErgebnisKonflikt k WHERE k.ergebnis = ?1 ORDER BY k.id<br>
* SQL: <br>
*/
@Override
public java.util.List<ErgebnisKonflikt> findByErgebnisOrderById( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("ErgebnisKonflikt.findByErgebnisOrderById" ,  ergebnis  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByErgebnisOrderById(): Miss");
        }

        cache.put(key, super.findByErgebnisOrderById( ergebnis  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByErgebnisOrderById(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<ErgebnisKonflikt>) cache.lookup(key));
    }

    return super.findByErgebnisOrderById( ergebnis  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
